zenilib: zenilib/jni/external/sdl/SDL/SDL_joystick.h File Reference

zenilib 0.5.3.0

- Main Page
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
Classes | Typedefs | Functions
SDL_joystick.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_error.h"`
`#include "begin_code.h"`
`#include "close_code.h"`

Go to the source code of this file.

## Classes

struct | SDL_JoystickGUID

## Macros

Hat positions
#define | SDL_HAT_CENTERED 0x00
#define | SDL_HAT_UP 0x01
#define | SDL_HAT_RIGHT 0x02
#define | SDL_HAT_DOWN 0x04
#define | SDL_HAT_LEFT 0x08
#define | SDL_HAT_RIGHTUP (SDL_HAT_RIGHT|SDL_HAT_UP)
#define | SDL_HAT_RIGHTDOWN (SDL_HAT_RIGHT|SDL_HAT_DOWN)
#define | SDL_HAT_LEFTUP (SDL_HAT_LEFT|SDL_HAT_UP)
#define | SDL_HAT_LEFTDOWN (SDL_HAT_LEFT|SDL_HAT_DOWN)

## Typedefs

typedef struct _SDL_Joystick | SDL_Joystick
typedef Sint32 | SDL_JoystickID

## Functions

DECLSPEC void SDLCALL | SDL_JoystickClose (SDL_Joystick *joystick)
DECLSPEC int SDLCALL | SDL_JoystickEventState (int state)
DECLSPEC SDL_bool SDLCALL | SDL_JoystickGetAttached (SDL_Joystick *joystick)
DECLSPEC Sint16 SDLCALL | SDL_JoystickGetAxis (SDL_Joystick *joystick, int axis)
DECLSPEC int SDLCALL | SDL_JoystickGetBall (SDL_Joystick *joystick, int ball, int *dx, int *dy)
DECLSPEC Uint8 SDLCALL | SDL_JoystickGetButton (SDL_Joystick *joystick, int button)
DECLSPEC SDL_JoystickGUID SDLCALL | SDL_JoystickGetDeviceGUID (int device_index)
DECLSPEC SDL_JoystickGUID SDLCALL | SDL_JoystickGetGUID (SDL_Joystick *joystick)
DECLSPEC SDL_JoystickGUID SDLCALL | SDL_JoystickGetGUIDFromString (const char *pchGUID)
DECLSPEC void | SDL_JoystickGetGUIDString (SDL_JoystickGUID guid, char *pszGUID, int cbGUID)
DECLSPEC Uint8 SDLCALL | SDL_JoystickGetHat (SDL_Joystick *joystick, int hat)
DECLSPEC SDL_JoystickID SDLCALL | SDL_JoystickInstanceID (SDL_Joystick *joystick)
DECLSPEC const char *SDLCALL | SDL_JoystickName (SDL_Joystick *joystick)
DECLSPEC const char *SDLCALL | SDL_JoystickNameForIndex (int device_index)
DECLSPEC int SDLCALL | SDL_JoystickNumAxes (SDL_Joystick *joystick)
DECLSPEC int SDLCALL | SDL_JoystickNumBalls (SDL_Joystick *joystick)
DECLSPEC int SDLCALL | SDL_JoystickNumButtons (SDL_Joystick *joystick)
DECLSPEC int SDLCALL | SDL_JoystickNumHats (SDL_Joystick *joystick)
DECLSPEC SDL_Joystick *SDLCALL | SDL_JoystickOpen (int device_index)
DECLSPEC void SDLCALL | SDL_JoystickUpdate (void)
DECLSPEC int SDLCALL | SDL_NumJoysticks (void)

## Detailed Description

Include file for SDL joystick event handling

The term "device_index" identifies currently plugged in joystick devices between 0 and SDL_NumJoysticks, with the exact joystick behind a device_index changing as joysticks are plugged and unplugged.

The term "instance_id" is the current instantiation of a joystick device in the system, if the joystick is removed and then re-inserted then it will get a new instance_id, instance_id's are monotonically increasing identifiers of a joystick plugged in.

The term JoystickGUID is a stable 128-bit identifier for a joystick device that does not change over time, it identifies class of the device (a X360 wired controller for example). This identifier is platform dependent.

In order to use these functions, SDL_Init() must have been called with the SDL_INIT_JOYSTICK flag. This causes SDL to scan the system for joysticks, and load appropriate drivers.

If you would like to receive joystick updates while the application is in the background, you should set the following hint before calling SDL_Init(): SDL_HINT_JOYSTICK_ALLOW_BACKGROUND_EVENTS

Definition in file SDL_joystick.h.

## Macro Definition Documentation

#define SDL_HAT_CENTERED 0x00

Definition at line 191 of file SDL_joystick.h.

Referenced by SDL_JoystickUpdate(), and SDLTest_PrintEvent().

#define SDL_HAT_DOWN 0x04

Definition at line 194 of file SDL_joystick.h.

Referenced by SDL_GameControllerEventWatcher(), and SDLTest_PrintEvent().

#define SDL_HAT_LEFT 0x08

Definition at line 195 of file SDL_joystick.h.

Referenced by SDL_GameControllerEventWatcher(), and SDLTest_PrintEvent().

#define SDL_HAT_LEFTDOWN (SDL_HAT_LEFT|SDL_HAT_DOWN)

Definition at line 199 of file SDL_joystick.h.

Referenced by SDLTest_PrintEvent().

#define SDL_HAT_LEFTUP (SDL_HAT_LEFT|SDL_HAT_UP)

Definition at line 198 of file SDL_joystick.h.

Referenced by SDLTest_PrintEvent().

#define SDL_HAT_RIGHT 0x02

Definition at line 193 of file SDL_joystick.h.

Referenced by SDL_GameControllerEventWatcher(), and SDLTest_PrintEvent().

#define SDL_HAT_RIGHTDOWN (SDL_HAT_RIGHT|SDL_HAT_DOWN)

Definition at line 197 of file SDL_joystick.h.

Referenced by SDLTest_PrintEvent().

#define SDL_HAT_RIGHTUP (SDL_HAT_RIGHT|SDL_HAT_UP)

Definition at line 196 of file SDL_joystick.h.

Referenced by SDLTest_PrintEvent().

#define SDL_HAT_UP 0x01

Definition at line 192 of file SDL_joystick.h.

Referenced by SDL_GameControllerEventWatcher(), and SDLTest_PrintEvent().

## Typedef Documentation

typedef struct _SDL_Joystick SDL_Joystick

Definition at line 65 of file SDL_joystick.h.

typedef Sint32 SDL_JoystickID

Definition at line 72 of file SDL_joystick.h.

## Function Documentation

DECLSPEC void SDLCALL SDL_JoystickClose | ( | SDL_Joystick * | joystick | ) |

Close a joystick previously opened with SDL_JoystickOpen().

Definition at line 398 of file SDL_joystick.c.

References _SDL_Joystick::axes, _SDL_Joystick::balls, _SDL_Joystick::buttons, _SDL_Joystick::hats, _SDL_Joystick::name, _SDL_Joystick::next, NULL, _SDL_Joystick::ref_count, SDL_free(), SDL_joysticks, and SDL_SYS_JoystickClose().

Referenced by SDL_GameControllerClose(), SDL_JoystickOpen(), SDL_JoystickQuit(), and SDL_JoystickUpdate().

DECLSPEC int SDLCALL SDL_JoystickEventState | ( | int | state | ) |

Enable/disable joystick event polling.

If joystick events are disabled, you must call SDL_JoystickUpdate() yourself and check the state of the joystick when you want joystick information.

The state can be one of SDL_QUERY, SDL_ENABLE or SDL_IGNORE.

Definition at line 708 of file SDL_joystick.c.

References i, SDL_arraysize, SDL_DISABLE, SDL_ENABLE, SDL_EventState(), SDL_JOYAXISMOTION, SDL_JOYBALLMOTION, SDL_JOYBUTTONDOWN, SDL_JOYBUTTONUP, SDL_JOYDEVICEADDED, SDL_JOYDEVICEREMOVED, SDL_JOYHATMOTION, and SDL_QUERY.

Referenced by SDL_ShouldPollJoystick().

DECLSPEC SDL_bool SDLCALL SDL_JoystickGetAttached | ( | SDL_Joystick * | joystick | ) |

Returns SDL_TRUE if the joystick has been opened and currently connected, or SDL_FALSE if it has not.

Definition at line 359 of file SDL_joystick.c.

References SDL_FALSE, SDL_PrivateJoystickValid(), and SDL_SYS_JoystickAttached().

Referenced by Zeni::Controllers::detect_removed(), and SDL_GameControllerGetAttached().

DECLSPEC Sint16 SDLCALL SDL_JoystickGetAxis | ( | SDL_Joystick * | joystick,
|  | int | axis
| ) |  |

Get the current state of an axis control on a joystick.

The state is a value ranging from -32768 to 32767.

The axis indices start at index 0.

Definition at line 270 of file SDL_joystick.c.

References _SDL_Joystick::axes, _SDL_Joystick::naxes, SDL_PrivateJoystickValid(), and SDL_SetError().

Referenced by SDL_GameControllerGetAxis(), and SDL_GameControllerGetButton().

DECLSPEC int SDLCALL SDL_JoystickGetBall | ( | SDL_Joystick * | joystick,
|  | int | ball,
|  | int * | dx,
|  | int * | dy
| ) |  |

Get the ball axis change since the last poll.

Returns
  0, or -1 if you passed it invalid parameters.

The ball indices start at index 0.

Definition at line 310 of file SDL_joystick.c.

References _SDL_Joystick::balls, _SDL_Joystick::balldelta::dx, _SDL_Joystick::balldelta::dy, _SDL_Joystick::nballs, SDL_PrivateJoystickValid(), and SDL_SetError().

DECLSPEC Uint8 SDLCALL SDL_JoystickGetButton | ( | SDL_Joystick * | joystick,
|  | int | button
| ) |  |

Get the current state of a button on a joystick.

The button indices start at index 0.

Definition at line 338 of file SDL_joystick.c.

References _SDL_Joystick::buttons, _SDL_Joystick::nbuttons, SDL_PrivateJoystickValid(), and SDL_SetError().

Referenced by SDL_GameControllerGetAxis(), and SDL_GameControllerGetButton().

DECLSPEC SDL_JoystickGUID SDLCALL SDL_JoystickGetDeviceGUID | ( | int | device_index | ) |

Return the GUID for the joystick at this index

Definition at line 752 of file SDL_joystick.c.

References SDL_NumJoysticks(), SDL_SetError(), SDL_SYS_JoystickGetDeviceGUID(), and SDL_zero.

Referenced by SDL_PrivateGetControllerMapping().

DECLSPEC SDL_JoystickGUID SDLCALL SDL_JoystickGetGUID | ( | SDL_Joystick * | joystick | ) |

Return the GUID for this opened joystick

Definition at line 764 of file SDL_joystick.c.

References SDL_SYS_JoystickGetGUID().

Referenced by Zeni::Controllers::device_added().

DECLSPEC SDL_JoystickGUID SDLCALL SDL_JoystickGetGUIDFromString | ( | const char * | pchGUID | ) |

convert a string into a joystick formatted guid

Definition at line 824 of file SDL_joystick.c.

References i, nibble(), SDL_memset(), and SDL_strlen().

Referenced by SDL_GameControllerAddMapping().

DECLSPEC void SDL_JoystickGetGUIDString | ( | SDL_JoystickGUID | guid,
|  | char * | pszGUID,
|  | int | cbGUID
| ) |  |

Return a string representation for this guid. pszGUID must point to at least 33 bytes (32 for the string plus a NULL terminator).

Definition at line 770 of file SDL_joystick.c.

References SDL_JoystickGUID::data, i, and NULL.

Referenced by Zeni::Controllers::device_added(), and SDL_GameControllerMappingForGUID().

DECLSPEC Uint8 SDLCALL SDL_JoystickGetHat | ( | SDL_Joystick * | joystick,
|  | int | hat
| ) |  |

Get the current state of a POV hat on a joystick.

The hat indices start at index 0.

Returns
  The return value is one of the following positions:
  - SDL_HAT_CENTERED
  - SDL_HAT_UP
  - SDL_HAT_RIGHT
  - SDL_HAT_DOWN
  - SDL_HAT_LEFT
  - SDL_HAT_RIGHTUP
  - SDL_HAT_RIGHTDOWN
  - SDL_HAT_LEFTUP
  - SDL_HAT_LEFTDOWN

Definition at line 290 of file SDL_joystick.c.

References _SDL_Joystick::hats, _SDL_Joystick::nhats, SDL_PrivateJoystickValid(), and SDL_SetError().

Referenced by SDL_GameControllerGetButton().

DECLSPEC SDL_JoystickID SDLCALL SDL_JoystickInstanceID | ( | SDL_Joystick * | joystick | ) |

Get the instance ID of an opened joystick or -1 if the joystick is invalid.

Definition at line 372 of file SDL_joystick.c.

References _SDL_Joystick::instance_id, and SDL_PrivateJoystickValid().

Referenced by Zeni::Controllers::device_added().

DECLSPEC const char* SDLCALL SDL_JoystickName | ( | SDL_Joystick * | joystick | ) |

Return the name for this currently opened joystick. If no name can be found, this function returns NULL.

Definition at line 385 of file SDL_joystick.c.

References _SDL_Joystick::name, NULL, and SDL_PrivateJoystickValid().

Referenced by Zeni::Controllers::get_controller_name().

DECLSPEC const char* SDLCALL SDL_JoystickNameForIndex | ( | int | device_index | ) |

Get the implementation dependent name of a joystick. This can be called before any joysticks are opened. If no name can be found, this function returns NULL.

Definition at line 84 of file SDL_joystick.c.

References NULL, SDL_NumJoysticks(), SDL_SetError(), and SDL_SYS_JoystickNameForDeviceIndex().

DECLSPEC int SDLCALL SDL_JoystickNumAxes | ( | SDL_Joystick * | joystick | ) |

Get the number of general axis controls on a joystick.

Definition at line 222 of file SDL_joystick.c.

References _SDL_Joystick::naxes, and SDL_PrivateJoystickValid().

DECLSPEC int SDLCALL SDL_JoystickNumBalls | ( | SDL_Joystick * | joystick | ) |

Get the number of trackballs on a joystick.

Joystick trackballs have only relative motion events associated with them and their state cannot be polled.

Definition at line 246 of file SDL_joystick.c.

References _SDL_Joystick::nballs, and SDL_PrivateJoystickValid().

DECLSPEC int SDLCALL SDL_JoystickNumButtons | ( | SDL_Joystick * | joystick | ) |

Get the number of buttons on a joystick.

Definition at line 258 of file SDL_joystick.c.

References _SDL_Joystick::nbuttons, and SDL_PrivateJoystickValid().

DECLSPEC int SDLCALL SDL_JoystickNumHats | ( | SDL_Joystick * | joystick | ) |

Get the number of POV hats on a joystick.

Definition at line 234 of file SDL_joystick.c.

References _SDL_Joystick::nhats, and SDL_PrivateJoystickValid().

DECLSPEC SDL_Joystick* SDLCALL SDL_JoystickOpen | ( | int | device_index | ) |

Open a joystick for use. The index passed as an argument refers tothe N'th joystick on the system. This index is the value which will identify this joystick in future joystick events.

Returns
  A joystick identifier, or NULL if an error occurred.

Definition at line 101 of file SDL_joystick.c.

References _SDL_Joystick::axes, _SDL_Joystick::balls, _SDL_Joystick::buttons, _SDL_Joystick::hats, _SDL_Joystick::instance_id, _SDL_Joystick::name, _SDL_Joystick::naxes, _SDL_Joystick::nballs, _SDL_Joystick::nbuttons, _SDL_Joystick::next, _SDL_Joystick::nhats, NULL, _SDL_Joystick::ref_count, SDL_free(), SDL_JoystickClose(), SDL_joysticks, SDL_malloc(), SDL_memset(), SDL_NumJoysticks(), SDL_OutOfMemory, SDL_SetError(), SDL_strdup(), SDL_SYS_GetInstanceIdOfDeviceIndex(), SDL_SYS_JoystickNameForDeviceIndex(), SDL_SYS_JoystickOpen(), and SDL_SYS_JoystickUpdate().

Referenced by Zeni::Controllers::device_added(), and SDL_GameControllerOpen().

DECLSPEC void SDLCALL SDL_JoystickUpdate | ( | void |  | ) |

Update the current state of the open joysticks.

This is called automatically by the event loop if any joystick events are enabled.

Definition at line 657 of file SDL_joystick.c.

References _SDL_Joystick::closed, i, _SDL_Joystick::naxes, _SDL_Joystick::nbuttons, _SDL_Joystick::next, _SDL_Joystick::nhats, NULL, _SDL_Joystick::ref_count, SDL_HAT_CENTERED, SDL_JoystickClose(), SDL_joysticks, SDL_PrivateJoystickAxis(), SDL_PrivateJoystickButton(), SDL_PrivateJoystickHat(), SDL_SYS_JoystickDetect(), SDL_SYS_JoystickUpdate(), and _SDL_Joystick::uncentered.

Referenced by SDL_GameControllerUpdate(), and SDL_PumpEvents().

DECLSPEC int SDLCALL SDL_NumJoysticks | ( | void |  | ) |

Count the number of joysticks attached to the system right now

Definition at line 75 of file SDL_joystick.c.

References SDL_SYS_NumJoysticks().

Referenced by SDL_GameControllerOpen(), SDL_JoystickGetDeviceGUID(), SDL_JoystickNameForIndex(), and SDL_JoystickOpen().